#include <stdint.h>
#include <stdbool.h>
#include <string.h>
#include <util/delay.h>

#include "HAL.h"

static void delayMillis(uint16_t aMillis) {
	while (aMillis != 0) {
		_delay_ms(1);
		aMillis--;
	}
}

enum CkDiv {
	DIV1 = 1,
	DIV2 = 2,
	DIV4 = 3,
	DIV8 = 4,
	DIV16 = 5,
	DIV32 = 6,
	DIV64 = 7,
	DIV128 = 8,
	DIV256 = 9,
	DIV512 = 10,
	DIV1024 = 11,
	DIV2048 = 12,
	DIV4096 = 13,
	DIV8192 = 14,
	DIV16384 = 15,
};

static void disableOutput(void) {
	OCR1B = 0;
	OCR1C = 1;
}

static void setOutput(enum CkDiv aCkDiv, unsigned char aOcrReg) {
	OCR1C = aOcrReg;
	OCR1B = (aOcrReg + 1) / 2;
	TCCR1B = (TCCR1B & ~(15)) | aCkDiv;
}

static void play(void) {
	setOutput(DIV16, 189);
	delayMillis(240);
	disableOutput();
	delayMillis(120);
	setOutput(DIV16, 179);
	delayMillis(120);
	setOutput(DIV16, 159);
	delayMillis(120);
	disableOutput();
	delayMillis(120);
	setOutput(DIV8, 239);
	delayMillis(720);
	disableOutput();
	delayMillis(180);
	setOutput(DIV16, 213);
	delayMillis(240);
	disableOutput();
	delayMillis(120);
	setOutput(DIV16, 189);
	delayMillis(120);
	setOutput(DIV16, 179);
	delayMillis(960);
	disableOutput();
	delayMillis(360);
	setOutput(DIV16, 159);
	delayMillis(240);
	disableOutput();
	delayMillis(120);
	setOutput(DIV16, 142);
	delayMillis(120);
	setOutput(DIV8, 253);
	delayMillis(120);
	disableOutput();
	delayMillis(120);
	setOutput(DIV8, 179);
	delayMillis(720);
	disableOutput();
	delayMillis(240);
	setOutput(DIV16, 142);
	delayMillis(240);
	disableOutput();
	delayMillis(120);
	setOutput(DIV8, 253);
	delayMillis(120);
	setOutput(DIV8, 239);
	delayMillis(480);
	setOutput(DIV8, 213);
	delayMillis(480);
	setOutput(DIV8, 190);
	delayMillis(480);
	setOutput(DIV16, 189);
	delayMillis(240);
	disableOutput();
	delayMillis(120);
	setOutput(DIV16, 179);
	delayMillis(120);
	setOutput(DIV16, 159);
	delayMillis(120);
	disableOutput();
	delayMillis(120);
	setOutput(DIV8, 239);
	delayMillis(960);
	disableOutput();
	delayMillis(240);
	setOutput(DIV8, 213);
	delayMillis(240);
	disableOutput();
	delayMillis(120);
	setOutput(DIV8, 190);
	delayMillis(120);
	setOutput(DIV8, 179);
	delayMillis(960);
	setOutput(DIV16, 159);
	delayMillis(240);
	disableOutput();
	delayMillis(120);
	setOutput(DIV16, 159);
	delayMillis(120);
	setOutput(DIV8, 190);
	delayMillis(360);
	disableOutput();
	delayMillis(120);
	setOutput(DIV8, 213);
	delayMillis(240);
	disableOutput();
	delayMillis(120);
	setOutput(DIV16, 159);
	delayMillis(120);
	setOutput(DIV8, 190);
	delayMillis(360);
	disableOutput();
	delayMillis(120);
	setOutput(DIV8, 213);
	delayMillis(240);
	disableOutput();
	delayMillis(120);
	setOutput(DIV16, 159);
	delayMillis(120);
	setOutput(DIV8, 179);
	delayMillis(360);
	disableOutput();
	delayMillis(120);
	setOutput(DIV8, 190);
	delayMillis(240);
	disableOutput();
	delayMillis(120);
	setOutput(DIV8, 213);
	delayMillis(120);
	setOutput(DIV8, 239);
	delayMillis(960);	
}

int main() {
	/* Configure outputs correctly */
	initHAL();

	/* Enable OC1B */
	TCCR1A = _BV(COM1B0) | _BV(PWM1B);

	while (true) {
		play();
		disableOutput();
		delayMillis(5000);
	}

	return 0;
}


